import * as React from 'react';
import { Redirect, RouteComponentProps, RouteProps, Route, Switch } from 'react-router-dom';
import { Container, Menu, Sidebar, Segment, Icon, Breadcrumb, Grid, Dropdown } from 'semantic-ui-react';
import { Header } from './Header';
import { Footer } from './Footer';
import TitleBarContainer from './TitleBarContainer';
import LeftMenu from './LeftMenu';

import ProbeDetail from '../../views/monitoring/probe/Detail';
import ProbeHistory from '../../views/monitoring/probe/History';


export interface Props extends RouteComponentProps<any> {
}
export interface State {
  currUrl: string;
}

export class ProbeDetailLayout extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      currUrl: this.props.location.pathname,
    };
  }


  public render(): JSX.Element {
    const sub = [
      {
        'name': 'Info',
        'path': this.state.currUrl,
      },
      {
        'name': 'History',
        'path': this.state.currUrl + '/history',
      },
    ];
    return (
      <Container fluid>
        <LeftMenu />
        <Segment vertical style={{ margin: '0 0 0 210px', padding: '0' }}>
          <Header />
          <TitleBarContainer sub={sub}/>
          <Switch>
            <Route exact={true} path={`${this.props.match.url}/:id`} component={ProbeDetail} />
            <Route exact={true} path={`${this.props.match.url}/:id/history`} component={ProbeHistory} />
          </Switch>
          <Footer />
        </Segment>
      </Container >
    );
  }
}

export default ProbeDetailLayout;

